<?php
/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  alessandrobartels
 *
 */
class Inicializa{



    static $container;
    static $_nrOrg;
    static $_listaEventoHoraExtra;
    static $_listaEventoAdicionalNoturno;

//@codingStandardsIgnoreStart

    /**
     * Enter description here ...
     *
     * @param integer $nrOrg       Numero Organizacao.
     * @param integer $nrOrgPadrao Numero da Organizacao Padrao.
     *
     * @return mixed
     */
    public static function Container($nrOrg, $nrOrgPadrao = null, $mesCompetencia = null, $dtPagamento = null) {

        self::$container = TkDI::getContainer();
        self::$_nrOrg = $nrOrg;


        self::$container->pessoa = self::$container->asShared(
            function() use($nrOrg, $mesCompetencia){
                return new GpepessoaEntity(null, $nrOrg, $mesCompetencia);
            }
        );

        self::$container->vinculom = self::$container->asShared(
            function(){
                return new GpevinculomEntity();
            }
        );

        self::$container->dependencia = self::$container->asShared(
            function() use($nrOrg, $nrOrgPadrao){
                return new FpadepvinculoEntity(null, $nrOrg, $nrOrgPadrao);
            }
        );

        self::$container->tipo_dependencia = self::$container->asShared(
            function(){
                return new FpatipodependeEntity();
            }
        );

        self::$container->escalam = self::$container->asShared(
            function(){
                return new GpeescalatrabmEntity();
            }
        );

        self::$container->situacao_funcional = self::$container->asShared(
            function(){
                return new GpesitufuncmEntity();
            }
        );

        self::$container->alteracao_situacao_funcional = self::$container->asShared(
            function() use($nrOrg, $nrOrgPadrao, $mesCompetencia){
                return new GpealtesitufuncEntity(null, $nrOrg, $nrOrgPadrao, $mesCompetencia);
            }
        );

        /* Nao utilizar */
        self::$container->tipo_ferias = self::$container->asShared(
            function(){
                tk_message('Tipo de ferias ja esta instanciado em Ferias. N�o deve ser utilizado do Container','error');
                die();
                return new FpatipoferiasmEntity();
            }
        );

        self::$container->ferias = self::$container->asShared(
            function() use($nrOrg, $nrOrgPadrao, $mesCompetencia){
                return new FpaferiasEntity(null, $nrOrg, $nrOrgPadrao, $mesCompetencia);
            }
        );

        self::$container->gozo_ferias = self::$container->asShared(
            function(){
                return new FpagozoferiasEntity();
            }
        );

        self::$container->faltas_intervalo = self::$container->asShared(
            function() use($nrOrg, $nrOrgPadrao){
                return new EventosFaltasIntervalo($nrOrg, $nrOrgPadrao);
            }
        );



        self::$container->tipo_calculo = self::$container->asShared(
            function(){
                return new FpatipocalculoEntity();
            }
        );

        self::$container->tp_calc_mov = self::$container->asShared(
            function(){
                return new FpatpcalcmovEntity();
            }
        );

        self::$container->calculo_folha = self::$container->asShared(
            function(){
                return new FpacalculofolhaEntity();
            }
        );

        self::$container->itens_calculo = self::$container->asShared(
            function(){
                return new FpaitecalcfolhaEntity();
            }
        );



        self::$container->eventom = self::$container->asShared(
            function() use($nrOrg, $nrOrgPadrao, $mesCompetencia, $dtPagamento){
                return new FpaeventomEntity(null, $nrOrg, $nrOrgPadrao, $mesCompetencia, $dtPagamento);
            }
        );

        self::$container->tipo_assoc = self::$container->asShared(
            function(){
                return new FpatipoassoceveEntity();
            }
        );


        self::$container->assoc_eventos = self::$container->asShared(
            function() use($nrOrg,$nrOrgPadrao){
                return new FpaassoceventoEntity(null,$nrOrg,$nrOrgPadrao);
            }
        );


        self::$container->param_calculo = self::$container->asShared(
            function() use($nrOrg, $nrOrgPadrao, $mesCompetencia) {
                return new ParametrosCalculo($nrOrg, $nrOrgPadrao, $mesCompetencia);
            }
        );


    }

    public static function carregaVariaveis(){
        self::_carregaHoraExtra();
        self::_carregaAdicionalNoturno();

    }


    private static function _carregaHoraExtra(){

        /** @var $tipoAssociacao FpatipoassoceveEntity */
        $tipoAssociacao = self::$container->tipo_assoc;
        $horasExtra = $tipoAssociacao->getHoraExtra();
        self::$_listaEventoHoraExtra = self::$container->assoc_eventos->determinaReferenciaEventoAssociado(
            $horasExtra, self::$container->eventom
        );
    }


    public static function getListaEventoHoraExtra(){

        return self::$_listaEventoHoraExtra;
    }


    private static function _carregaAdicionalNoturno(){

        /** @var $tipoAssociacao FpatipoassoceveEntity */
        $tipoAssociacao = self::$container->tipo_assoc;
        $adicionalNoturno = $tipoAssociacao->getAdicionalNoturno();
        self::$_listaEventoAdicionalNoturno = self::$container->assoc_eventos->determinaReferenciaEventoAssociado(

        $adicionalNoturno, self::$container->eventom
        );
    }


    public static function getListaEventoAdicionalNoturno(){

        return self::$_listaEventoAdicionalNoturno;
    }

//@codingStandardsIgnoreEnd

}