<?php

require_once 'base/FuncionarioEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 * 
 * @package Entity
 * 
 * @author
 */
class FuncionarioEntity extends FuncionarioEntityBase
{

	/**
     * Retorna um registro de Funcionário pelo Numero do parceiro.
     * 
     * @param integer $nrparcnegocio Numero do Parceiro de Negócio
     * @param integer $nrorg 		 Numero da Organização
     * 
     * @return array
     *
     * @author gustavosilva - 29/05/2012
     */
	public static function consultaFuncionarioParcnegocio($nrparcnegocio, $nrorg){
		
		return Funcionario::consultaFuncionarioParcnegocio($nrparcnegocio, $nrorg);
		
	}
	
	/**
     * Deleta um registro de Funcionário.
     * 
     * @param integer $nrparcnegocio Numero do Parceiro de Negócio
     * @param integer $nrorg 		 Numero da Organização
     * 
     * @return void
     *
     * @author gustavosilva - 29/05/2012
     */
	public static function deleteFuncionarioFromNrparcnegocio($nrparcnegocio, $nrorg){
		
		Funcionario::deleteFuncionarioFromNrparcnegocio($nrparcnegocio, $nrorg);
		
	}
	
	/**
     * Cria um novo registro de Funcionário.
     * 
     * @param integer $nrparcnegocio Numero do Parceiro de Negócio
     * @param string  $nome			 Nome do funcionário
     * @param integer $nrorg 		 Numero da Organização
     * @param integer $cdempresa	 Código da empresa
     * 
     * @return void
     *
     * @author gustavosilva - 29/05/2012
     */
	public static function createNewFuncionario($nrparcnegocio, $nome, $nrorg, $cdempresa){
		
		try{
			$funcionario = new self();
			$funcionario->setCdfunc(Novocodigo::geraCodigo(Ambiente::getNrorg(), 'CLIENTE', 10));
			$funcionario->setNmfunc($nome);
			$funcionario->setNrorg($nrorg);
			$funcionario->setCdempresa($cdempresa);
			$funcionario->setNrparcnegocio($nrparcnegocio);
			FctUtil::newEntityAudit($funcionario);
			$funcionario->persist();
		}catch (Exception $e){
			throw $e;
		}
	}
	

}

