/*+
|                                               |
|     Trigger: DTULTATU_IDIOMA                  |  
|     Tabela : IDIOMA                           |
|                                               |
|     Criao:                                  |
|     23/10/2007 - Leonardo Bispo               |
|                                               |
+*/


CREATE OR REPLACE TRIGGER DTULTATU_IDIOMA
BEFORE INSERT OR DELETE OR UPDATE
ON IDIOMA FOR EACH ROW 

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUIDIOMA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDIDIOM,0) <> NVL(:NEW.CDIDIOM,0)) OR
         (NVL(:OLD.NMIDIOMA,0) <> NVL(:NEW.NMIDIOMA,0)) THEN
         :NEW.DTULTATUIDIOMA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
         VALUES ('IDIOMA', '', 'CDIDIOM='||:OLD.CDIDIOM||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE IDIOMA MODIFY DTULTATUIDIOMA DEFAULT SYSDATE
/



-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_IDIOMA','5.01.008'); END;
/

