BEGIN
   DECLARE
      V_COUNT NUMBER;
   BEGIN
      V_COUNT := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM USER_SCHEDULER_JOBS
          WHERE JOB_NAME = 'JOB_REPLICACAO_FOS_CNC';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_REPLICACAO_FOS_CNC',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN REPLICACAO_FOS_CNC(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=HOURLY; BYMINUTE=0',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para exportar as vendas do FOS/VND para o sistema de conciliação de vendas de cartão de crédito (CNC).'
         );
      ELSE
         DBMS_SCHEDULER.DROP_JOB(JOB_NAME => 'JOB_REPLICACAO_FOS_CNC');
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_REPLICACAO_FOS_CNC',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN REPLICACAO_FOS_CNC(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=HOURLY; BYMINUTE=0',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para exportar as vendas do FOS/VND para o sistema de conciliação de vendas de cartão de crédito (CNC).'
         );
      END IF;
   END;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('AGENDA_REPLICACAO_CNC','6.10.000'); END;
/
